.install-cosign: &install-cosign
  - apk update
  - apk add wget
  - apk add rpm
  - wget "https://github.com/sigstore/cosign/releases/download/v2.0.0/cosign-2.0.0.x86_64.rpm"
  - rpm -ivh cosign-2.0.0.x86_64.rpm
  - cosign version


# build-image: # with docker
#   stage: build
#   image:
#     name: docker:stable
#   services:
#     - docker:dind
#   before_script:
#     - export IMAGE_NAME=$CI_REGISTRY_IMAGE/microservice
#     - export IMAGE_TAG=$SERVICE_VERSION
#   script:
#     - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
#     - docker build -t $IMAGE_NAME:$IMAGE_TAG .
#     - docker push $IMAGE_NAME:$IMAGE_TAG


build-image: # with shell
  stage: build
  tags:
    - sec-tools, ubuntu, local
  before_script:
    - export IMAGE_NAME=$CI_REGISTRY_IMAGE/microservice
    - export IMAGE_TAG=$SERVICE_VERSION
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $IMAGE_NAME:$IMAGE_TAG .
    - docker push $IMAGE_NAME:$IMAGE_TAG

# cosign-sign: # with docker
#   image:
#     name: docker:stable
#   services:
#     - docker:dind
#   stage: sign
#   before_script:
#     - *install-cosign
#   script:
#     - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
#     - echo y | cosign sign --key $COSIGN_PRIVATE_KEY $CI_REGISTRY_IMAGE/microservice:$SERVICE_VERSION

cosign-sign: # with shell
  tags:
    - sec-tools, ubuntu, local
  stage: build
  needs:
    - build-image
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - echo y | cosign sign --key $COSIGN_PRIVATE_KEY $CI_REGISTRY_IMAGE/microservice:$SERVICE_VERSION
  